%define anolis_release 2

%define tcpslice_dir tcpslice-1.7

Summary: A network traffic monitoring tool
Name: tcpdump
Epoch: 14
Version: 4.99.4
Release: %{anolis_release}%{?dist}
License: BSD with advertising
URL: http://www.tcpdump.org
Requires(pre): shadow-utils
BuildRequires: make
BuildRequires: automake openssl-devel libpcap-devel gcc
BuildRequires: systemd-rpm-macros

Source0: http://www.tcpdump.org/release/tcpdump-%{version}.tar.gz
Source1: https://github.com/the-tcpdump-group/tcpslice/archive/refs/tags/%{tcpslice_dir}.tar.gz
Source3: tcpdump-sysusers.conf

Patch0002:      0002-Use-getnameinfo-instead-of-gethostbyaddr.patch
Patch0003:      0003-Drop-root-priviledges-before-opening-first-savefile-.patch
Patch0007:      0007-Introduce-nn-option.patch
Patch0009:      0009-Change-n-flag-to-nn-in-TESTonce.patch
Patch0010:      0010-pgm-fix-the-way-we-step-through-the-packet.patch
Patch0011:      0011-pgm-don-t-advance-bp-by-the-option-haeder-length-twi.patch
Patch0012:      0012-CVE-2024-2397.patch

%description
Tcpdump is a command-line tool for monitoring network traffic.
Tcpdump can capture and display the packet headers on a particular
network interface or on all interfaces.  Tcpdump can display all of
the packet headers, or just the ones that match particular criteria.

Install tcpdump if you need a program to monitor network traffic.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -a 1 -p1

%build
export CFLAGS="$RPM_OPT_FLAGS $(getconf LFS_CFLAGS) -fno-strict-aliasing"

pushd tcpslice-%{tcpslice_dir}
# update config.{guess,sub}
automake -a -f 2> /dev/null || :
./autogen.sh
%configure
%{make_build}
popd

%configure --with-crypto --with-user=tcpdump --without-smi
%{make_build}

%check
%{make_build} check

%install
mkdir -p ${RPM_BUILD_ROOT}%{_libdir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}

pushd tcpslice-%{tcpslice_dir}
install -m755 tcpslice ${RPM_BUILD_ROOT}%{_sbindir}
install -m644 tcpslice.1 ${RPM_BUILD_ROOT}%{_mandir}/man8/tcpslice.8
popd

install -m755 tcpdump ${RPM_BUILD_ROOT}%{_sbindir}
install -m644 tcpdump.1 ${RPM_BUILD_ROOT}%{_mandir}/man8/tcpdump.8

install -p -D -m 0644 %{SOURCE3} ${RPM_BUILD_ROOT}%{_sysusersdir}/tcpdump.conf

# fix section numbers
sed -i 's/\(\.TH[a-zA-Z ]*\)[1-9]\(.*\)/\18\2/' \
	${RPM_BUILD_ROOT}%{_mandir}/man8/*

%pre
%sysusers_create_compat %{SOURCE3}
exit 0

%files
%license LICENSE
%{_sbindir}/tcpdump
%{_sbindir}/tcpslice
%{_sysusersdir}/tcpdump.conf
%{_mandir}/man8/tcpslice.8*
%{_mandir}/man8/tcpdump.8*

%files doc
%doc README.md CHANGES CREDITS

%changelog
* Sun May 05 2024 Funda Wang <fundawang@yeah.net> - 14:4.99.4-2
- New version of tcpslice
- fix CVE-2024-2397

* Wed Apr 12 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 14:4.99.4-1
- Init upstream from version 4.99.4
